<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: Script/curveGraphGenerator.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: Script/curveGraphGenerator.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * &lt;h3>Gaphical editor for curves&lt;/h3>
 * @module m_curveGraphGenerator_client
 */

/** @function 
 * @description exported function : needed to select and visualize audio data
 * &lt;p> - the internals of this function are described in the linked namespace
 * &lt;p>{@link m_curveGraphGenerator_client.m_1_curveGraphGenerator}
*/

function curveGraphGenerator(socket,generateCurve)
{
/**
     * Foo object (@see: {@link module:socketCom~function})
     * @name m_curveGraphGenerator_client
     * @inner
     * @private
     * @memberof module:m_curveGraphGenerator_client
     * @property {Object} m_curveGraphGenerator_client - The foo object
     * @property {Object} m_curveGraphGenerator_client.m_1_curveGraphGenerator - The bar object     
     */

 /**
     * This namespace describes the function body of the server sided socket.io
     * interface
     * @memberof m_curveGraphGenerator_client
     * @type {object}
     * @namespace m_curveGraphGenerator_client.m_1_curveGraphGenerator
     * 
     */

    /**
     * @memberof m_curveGraphGenerator_client.m_1_curveGraphGenerator
     * @type {object}
     */
    var d3 = window.d3;

    /**
     * @memberof m_curveGraphGenerator_client.m_1_curveGraphGenerator
     * @function create_list_and_double_svg          
     */
    d3.select('body').append('ul');
    var svg=d3.select('body').append('svg').attr('id','p_reate');
    d3.select('body').append('svg').attr('id','eta');

      if(!socket.connected)
      {
        socket.connect();    
      }

      /**     
          * @memberof m_curveGraphGenerator_client.m_1_curveGraphGenerator    
          * @event getCurve
          * @type {object}
          * @property {string} 1 - request mode 1 curve data      
      */ 
      socket.emit('getCurve',1);

      /**     
          * @memberof m_curveGraphGenerator_client.m_1_curveGraphGenerator    
          * @event sendCurve
          * @type {object}
          * @property {string} function - create 2d graphs according to mode 1 curve data      
      */ 
      socket.on('sendCurve',function(rawdata){
      
        var xmin,xmax,ymin,ymax,zmin,zmax;
        var pxy_vec=[],pxz_vec=[];

      /**     
          * @memberof m_curveGraphGenerator_client.m_1_curveGraphGenerator    
          * @function for_loop_curve_data
      */        
        for(var it=0; it&lt;rawdata.length;it++)
        {
          var x = rawdata[it].databuf[0];
          var y = rawdata[it].databuf[1];
          var z = rawdata[it].databuf[2];

          var xmin_bf = Math.min.apply(null, x),
              xmax_bf = Math.max.apply(null, x);

          var ymin_bf = Math.min.apply(null, y),
              ymax_bf = Math.max.apply(null, y);

          var zmin_bf = Math.min.apply(null, z),
              zmax_bf = Math.max.apply(null, z);    
              
          if(it==0)
          {
            xmin=xmin_bf
            xmax=xmax_bf

            ymin=ymin_bf
            ymax=ymax_bf

            zmin=zmin_bf
            zmin=zmax_bf
          }
          else
          {
            xmin = xmin &lt;= xmin_bf ? xmin : xmin_bf;
            xmax = xmax >= xmax_bf ? xmax : xmax_bf;

            ymin = ymin &lt;= ymin_bf ? ymin : ymin_bf;
            ymax = ymax >= ymax_bf ? ymax : ymax_bf;

            zmin = zmin &lt;= zmin_bf ? zmin : zmin_bf;
            zmax = zmax >= zmax_bf ? zmax : zmax_bf;
          }

        }           

        var wd = svg.node().width.baseVal.value;
        var hi = svg.node().height.baseVal.value;
        var val  = svg.node().width.baseVal;
        console.log("value: " + val.value +
            ", valueInSpecifiedUnits: " + val.unitType + ": " + val.valueInSpecifiedUnits +
            ", valueAsString: " + val.valueAsString);
        
        var scale_facx = wd/(xmax-xmin);
        var scale_facy = hi/(ymax-ymin);
        var scale_facz = hi/(zmax-zmin);
        var element3d = document.getElementById("p_reate");   
        var eta3d = document.getElementById("eta");   
        
        var x_,y_,z_,x_prev=null,z_prev=null,y_prev=null;
        for(it=0; it&lt;rawdata.length;it++)
        {
          x = rawdata[it].databuf[0];
          y = rawdata[it].databuf[1];
          z = rawdata[it].databuf[2];

          var vector = []; 

          var c=d3.hsl((50*it), 0.6, 0.5).rgb();
          console.log(it);
          
          var SelCurve = d3.select(element3d).append('g').attr('class','curvesY');          
          var SelCirc = SelCurve.append('g');
          var SelLine = SelCurve.append('g');
          var datObj = {};
          datObj.x = x;
          datObj.y = y;
          SelCurve.data([datObj]);
          for (var i=0;i&lt;x.length;i+=1)
          {          
            var coord = [scale_facx*(x[i]-xmin),scale_facy*(y[i]-ymin)];
            vector.push(coord);
            x_ = scale_facx*(x[i]-xmin);
            y_ = hi-scale_facy*(y[i]-ymin);
            SelCirc.append('circle').attr('cx',x_).attr('cy',y_).attr('r',5).attr('stroke','black').attr('fill',c);            
            if(x_prev !== null)
            {
              SelLine.append('line').attr('x1',x_prev).attr('y1',y_prev).attr('x2',x_).attr('y2',y_).attr('style',"stroke:rgb(0,0,0);stroke-width:1");
            }         
            
            x_prev = x_;
            y_prev = y_; 
          }
          x_prev = null;
          var pxy = d3.line()(vector);
          pxy_vec.push(pxy);


          SelCurve = d3.select(eta3d).append('g').attr('class','curvesZ');
          SelCirc = SelCurve.append('g');
          SelLine = SelCurve.append('g');
          datObj = {};
          datObj.x = x;
          datObj.y = z;
          SelCurve.data([datObj]);
          vector = [];          
          for (i=0;i&lt;x.length;i+=1)
          {    
           
            coord = [scale_facx*(x[i]-xmin),scale_facz*(z[i]-zmin)];
            vector.push(coord);
            x_ = scale_facx*(x[i]-xmin);
            z_ = hi-scale_facz*(z[i]-zmin);
            SelCirc.append('circle').attr('cx',x_).attr('cy',z_).attr('r',5).attr('stroke','black').attr('fill',c);   
            if(x_prev !== null)
            {
              SelLine.append('line').attr('x1',x_prev).attr('y1',z_prev).attr('x2',x_).attr('y2',z_).attr('style',"stroke:rgb(0,0,0);stroke-width:1");
            }         
            
            x_prev = x_;
            z_prev = z_;            
          }
          x_prev = null;
          var pxz = d3.line()(vector);
          pxz_vec.push(pxz); 
        }

        
        element3d = document.getElementById("p_reate");       
        d3.select(element3d).data([rawdata])
        generateCurve(d3.select);        

      });
    }
    export {curveGraphGenerator};
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
